# Generated via
#  `rails generate hyrax:work Dataset`
class DatasetIndexer < RdmsIndexer
  # This indexes the default metadata. You can remove it if you want to
  # provide your own metadata and indexing.
  include Hyrax::IndexesBasicMetadata

  # Fetch remote labels for based_near. You can remove this if you don't want
  # this behavior
  include Hyrax::IndexesLinkedMetadata

  # Custom indexers for dataset model
  include ComplexField::PersonIndexer
  include ComplexField::DateIndexer
  include ComplexField::IdentifierIndexer
  include ComplexField::FundrefIndexer
  include ComplexField::RelationIndexer

  def self.facet_fields
    # solr fields that will be treated as facets
    super.tap do |fields|
      fields.concat ComplexField::DateIndexer.date_facet_fields
      fields.concat ComplexField::PersonIndexer.person_facet_fields
      fields.concat ComplexField::FundrefIndexer.fundref_facet_fields
    end
  end

  def self.search_fields
    # solr fields that will be used for a search
    super.tap do |fields|
      fields.concat ComplexField::IdentifierIndexer.identifier_search_fields
      fields.concat ComplexField::DateIndexer.date_search_fields
      fields.concat ComplexField::PersonIndexer.person_search_fields
      fields.concat ComplexField::FundrefIndexer.fundref_search_fields
    end
  end

  def self.show_fields
    # solr fields that will be used to display results on the record page
    super.tap do |fields|
      fields.concat ComplexField::IdentifierIndexer.identifier_show_fields
      fields.concat ComplexField::DateIndexer.date_show_fields
      fields.concat ComplexField::PersonIndexer.person_show_fields
      fields.concat ComplexField::FundrefIndexer.fundref_show_fields
    end
  end

end
