# Generated via
#  `rails generate hyrax:work CrcDataset`
require 'rails_helper'

RSpec.describe Hyrax::CrcDatasetForm do
  subject { form }
  let(:model) { Dataset.new }
  let(:ability) { Ability.new(nil) }
  let(:request) { nil }
  let(:form) { described_class.new(model, ability, request) }
  it "has the expected terms" do
    expect(form.terms).to include(:parent_work_id)
    expect(form.terms).to include(:title)
    expect(form.terms).to include(:experiment_title)
    expect(form.terms).to include(:experiment_description)
    expect(form.terms).to include(:complex_person)
    expect(form.terms).to include(:crc_resource_type)
    expect(form.terms).to include(:coverage)
    expect(form.terms).to include(:approval_number)
    expect(form.terms).to include(:extra_information)
    expect(form.terms).to include(:complex_subject)
    expect(form.terms).to include(:modality)
    expect(form.terms).to include(:complex_identifier)
    expect(form.terms).to include(:complex_date)
    expect(form.terms).to include(:subject)
    expect(form.terms).to include(:publisher)
    expect(form.terms).to include(:language)
    expect(form.terms).to include(:complex_funding_reference)
    expect(form.terms).to include(:description)
    expect(form.terms).to include(:keyword)
    expect(form.terms).to include(:resource_type)
    expect(form.terms).to include(:doi)
    expect(form.terms).to include(:complex_relation)
    expect(form.terms).to include(:software_version)
  end

  context 'work type experiment' do
    it 'has the correct experiment primary terms' do
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:title)
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:experiment_title)
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:experiment_description)
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:complex_person)
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:crc_resource_type)
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:coverage)
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:approval_number)
      expect(form.primary_terms_by_work_type(work_type="experiment")).to include(:extra_information)
    end

    it 'has the correct experiment secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:complex_subject)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:modality)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:complex_identifier)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:complex_date)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:subject)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:publisher)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:language)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:complex_funding_reference)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:description)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:keyword)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:resource_type)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:doi)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:complex_relation)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).to include(:software_version)
    end

    it 'excludes primary terms from secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:title)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:experiment_title)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:experiment_description)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:complex_person)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:crc_resource_type)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:coverage)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:approval_number)
      expect(form.secondary_terms_by_work_type(work_type="experiment")).not_to include(:extra_information)
    end
  end

  context 'work type subject' do
    it 'has the correct subject primary terms' do
      expect(form.primary_terms_by_work_type(work_type="subject")).to include(:title)
      expect(form.primary_terms_by_work_type(work_type="subject")).to include(:complex_subject)
    end

    it 'has the correct subject secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:experiment_title)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:experiment_description)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:complex_person)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:crc_resource_type)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:coverage)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:approval_number)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:extra_information)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:modality)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:complex_identifier)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:complex_date)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:subject)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:publisher)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:language)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:complex_funding_reference)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:description)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:keyword)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:resource_type)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:doi)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:complex_relation)
      expect(form.secondary_terms_by_work_type(work_type="subject")).to include(:software_version)
    end

    it 'excludes primary terms from secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="subject")).not_to include(:title)
      expect(form.secondary_terms_by_work_type(work_type="subject")).not_to include(:complex_subject)
    end
  end

  context 'work type session' do
    it 'has the correct session primary terms' do
      expect(form.primary_terms_by_work_type(work_type="session")).to include(:title)
      expect(form.primary_terms_by_work_type(work_type="session")).to include(:complex_date)
    end

    it 'has the correct session secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:experiment_title)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:experiment_description)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:complex_person)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:crc_resource_type)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:coverage)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:approval_number)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:extra_information)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:complex_subject)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:modality)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:complex_identifier)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:subject)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:publisher)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:language)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:complex_funding_reference)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:description)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:keyword)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:resource_type)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:doi)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:complex_relation)
      expect(form.secondary_terms_by_work_type(work_type="session")).to include(:software_version)
    end

    it 'excludes primary terms from secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="session")).not_to include(:title)
      expect(form.secondary_terms_by_work_type(work_type="session")).not_to include(:complex_date)
    end
  end

  context 'work type modality' do
    it 'has the correct modality primary terms' do
      expect(form.primary_terms_by_work_type(work_type="modality")).to include(:title)
      expect(form.primary_terms_by_work_type(work_type="modality")).to include(:modality)
    end

    it 'has the correct modality secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:experiment_title)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:experiment_description)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:complex_person)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:crc_resource_type)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:coverage)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:approval_number)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:extra_information)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:complex_subject)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:complex_identifier)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:complex_date)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:subject)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:publisher)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:language)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:complex_funding_reference)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:description)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:keyword)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:resource_type)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:doi)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:complex_relation)
      expect(form.secondary_terms_by_work_type(work_type="modality")).to include(:software_version)
    end

    it 'excludes primary terms from secondary terms' do
      expect(form.secondary_terms_by_work_type(work_type="modality")).not_to include(:title)
      expect(form.secondary_terms_by_work_type(work_type="modality")).not_to include(:modality)
    end
  end

  context 'required fields' do
    it 'has the correct fields for experiment' do
      expect(form.required_fields_by_type(work_type="experiment")).to contain_exactly(
                                                                        :title,
                                                                        :experiment_description,
                                                                        :complex_person,
                                                                        :crc_resource_type,
                                                                        :coverage
                                                                      )
    end

    it 'has the correct fields for subject' do
      expect(form.required_fields_by_type(work_type="subject")).to contain_exactly(
                                                                        :title,
                                                                        :complex_subject
                                                                      )
    end

    it 'has the correct fields for session' do
      expect(form.required_fields_by_type(work_type="session")).to contain_exactly(
                                                                     :title,
                                                                     :complex_date
                                                                   )
    end

    it 'has the correct fields for modality' do
      expect(form.required_fields_by_type(work_type="modality")).to contain_exactly(
                                                                     :title,
                                                                     :modality
                                                                   )
    end
  end


  describe '#build_permitted_params' do
    subject { described_class.build_permitted_params }

    # it { is_expected.to include(:member_of_collection_ids, :find_child_work) }

    context 'permitted params' do
      it do
        expect(described_class).to receive(:permitted_date_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_identifier_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_person_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_relation_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_fundref_params).at_least(:once).and_call_original
        expect(described_class).to receive(:permitted_subject_params).at_least(:once).and_call_original
        subject
      end
    end
  end
end
